"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "createBabelPresetChain", {
  enumerable: true,
  get: function() {
    return createBabelPresetChain;
  }
});
const createBabelPresetChain = () => {
  let presets = [];
  const blacks = [];
  const preset = (name) => {
    const presetExist = presets.find((plugin) => plugin.name === name);
    const isExist = Boolean(presetExist);
    const preset2 = presetExist || {
      name,
      options: []
    };
    const tap = (options2) => {
      preset2.options = options2;
      set();
    };
    const options = () => preset2.options;
    const del = () => {
      if (isExist) {
        presets = presets.filter((preset3) => !preset3.name.includes(name));
      }
    };
    const ban = () => {
      if (!blacks.includes(name)) {
        blacks.push(name);
      }
      del();
    };
    const set = () => {
      if (blacks.includes(name)) {
        throw new Error(`Preset: ${name} has been banned!, You can't set it.`);
      }
      if (!isExist) {
        presets.push(preset2);
      }
    };
    const use = (path, options2) => {
      preset2.path = path;
      preset2.options = options2 || [];
      set();
    };
    return {
      tap,
      delete: del,
      ban,
      options,
      filter: presets.filter,
      use
    };
  };
  const toJSON = () => presets.map((preset2) => preset2.options ? [
    preset2.path || preset2.name,
    ...preset2.options
  ] : preset2.path || preset2.name);
  const merge = (other) => {
    for (const preset2 of other.presets) {
      if (preset2.path) {
        chain.preset(preset2.name).use(preset2.path, preset2.options);
      } else {
        chain.preset(preset2.name).tap(preset2.options);
      }
    }
    return chain;
  };
  const chain = {
    preset,
    presets,
    blacks,
    toJSON,
    merge
  };
  return chain;
};
